/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

dojo.provide("custom.layers.dojo3");
dojo.provide("dojo.widget.ContentPane");
dojo.require("dojo.widget.*");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.string");
dojo.require("dojo.string.extras");
dojo.require("dojo.html.style");
dojo.widget.defineWidget("dojo.widget.ContentPane",dojo.widget.HtmlWidget,function(){
this._styleNodes=[];
this._onLoadStack=[];
this._onUnloadStack=[];
this._callOnUnload=false;
this._ioBindObj;
this.scriptScope;
this.bindArgs={};
},{isContainer:true,adjustPaths:true,href:"",extractContent:true,parseContent:true,cacheContent:true,preload:false,refreshOnShow:false,handler:"",executeScripts:false,scriptSeparation:true,loadingMessage:"Loading...",isLoaded:false,postCreate:function(_1,_2,_3){
if(this.handler!==""){
this.setHandler(this.handler);
}
if(this.isShowing()||this.preload){
this.loadContents();
}
},show:function(){
if(this.refreshOnShow){
this.refresh();
}else{
this.loadContents();
}
dojo.widget.ContentPane.superclass.show.call(this);
},refresh:function(){
this.isLoaded=false;
this.loadContents();
},loadContents:function(){
if(this.isLoaded){
return;
}
if(dojo.lang.isFunction(this.handler)){
this._runHandler();
}else{
if(this.href!=""){
this._downloadExternalContent(this.href,this.cacheContent&&!this.refreshOnShow);
}
}
},setUrl:function(_4){
this.href=_4;
this.isLoaded=false;
if(this.preload||this.isShowing()){
this.loadContents();
}
},abort:function(){
var _5=this._ioBindObj;
if(!_5||!_5.abort){
return;
}
_5.abort();
delete this._ioBindObj;
},_downloadExternalContent:function(_6,_7){
this.abort();
this._handleDefaults(this.loadingMessage,"onDownloadStart");
var _8=this;
this._ioBindObj=dojo.io.bind(this._cacheSetting({url:_6,mimetype:"text/html",handler:function(_9,_a,_b){
delete _8._ioBindObj;
if(_9=="load"){
_8.onDownloadEnd.call(_8,_6,_a);
}else{
var e={responseText:_b.responseText,status:_b.status,statusText:_b.statusText,responseHeaders:_b.getAllResponseHeaders(),text:"Error loading '"+_6+"' ("+_b.status+" "+_b.statusText+")"};
_8._handleDefaults.call(_8,e,"onDownloadError");
_8.onLoad();
}
}},_7));
},_cacheSetting:function(_d,_e){
for(var x in this.bindArgs){
if(dojo.lang.isUndefined(_d[x])){
_d[x]=this.bindArgs[x];
}
}
if(dojo.lang.isUndefined(_d.useCache)){
_d.useCache=_e;
}
if(dojo.lang.isUndefined(_d.preventCache)){
_d.preventCache=!_e;
}
if(dojo.lang.isUndefined(_d.mimetype)){
_d.mimetype="text/html";
}
return _d;
},onLoad:function(e){
this._runStack("_onLoadStack");
this.isLoaded=true;
},onUnLoad:function(e){
dojo.deprecated(this.widgetType+".onUnLoad, use .onUnload (lowercased load)",0.5);
},onUnload:function(e){
this._runStack("_onUnloadStack");
delete this.scriptScope;
if(this.onUnLoad!==dojo.widget.ContentPane.prototype.onUnLoad){
this.onUnLoad.apply(this,arguments);
}
},_runStack:function(_13){
var st=this[_13];
var err="";
var _16=this.scriptScope||window;
for(var i=0;i<st.length;i++){
try{
st[i].call(_16);
}
catch(e){
err+="\n"+st[i]+" failed: "+e.description;
}
}
this[_13]=[];
if(err.length){
var _18=(_13=="_onLoadStack")?"addOnLoad":"addOnUnLoad";
this._handleDefaults(_18+" failure\n "+err,"onExecError","debug");
}
},addOnLoad:function(obj,_1a){
this._pushOnStack(this._onLoadStack,obj,_1a);
},addOnUnload:function(obj,_1c){
this._pushOnStack(this._onUnloadStack,obj,_1c);
},addOnUnLoad:function(){
dojo.deprecated(this.widgetType+".addOnUnLoad, use addOnUnload instead. (lowercased Load)",0.5);
this.addOnUnload.apply(this,arguments);
},_pushOnStack:function(_1d,obj,_1f){
if(typeof _1f=="undefined"){
_1d.push(obj);
}else{
_1d.push(function(){
obj[_1f]();
});
}
},destroy:function(){
this.onUnload();
dojo.widget.ContentPane.superclass.destroy.call(this);
},onExecError:function(e){
},onContentError:function(e){
},onDownloadError:function(e){
},onDownloadStart:function(e){
},onDownloadEnd:function(url,_25){
_25=this.splitAndFixPaths(_25,url);
this.setContent(_25);
},_handleDefaults:function(e,_27,_28){
if(!_27){
_27="onContentError";
}
if(dojo.lang.isString(e)){
e={text:e};
}
if(!e.text){
e.text=e.toString();
}
e.toString=function(){
return this.text;
};
if(typeof e.returnValue!="boolean"){
e.returnValue=true;
}
if(typeof e.preventDefault!="function"){
e.preventDefault=function(){
this.returnValue=false;
};
}
this[_27](e);
if(e.returnValue){
switch(_28){
case true:
case "alert":
alert(e.toString());
break;
case "debug":
dojo.debug(e.toString());
break;
default:
if(this._callOnUnload){
this.onUnload();
}
this._callOnUnload=false;
if(arguments.callee._loopStop){
dojo.debug(e.toString());
}else{
arguments.callee._loopStop=true;
this._setContent(e.toString());
}
}
}
arguments.callee._loopStop=false;
},splitAndFixPaths:function(s,url){
var _2b=[],_2c=[],tmp=[];
var _2e=[],_2f=[],_30=[],_31=[];
var str="",_33="",fix="",_35="",tag="",_37="";
if(!url){
url="./";
}
if(s){
var _38=/<title[^>]*>([\s\S]*?)<\/title>/i;
while(_2e=_38.exec(s)){
_2b.push(_2e[1]);
s=s.substring(0,_2e.index)+s.substr(_2e.index+_2e[0].length);
}
if(this.adjustPaths){
var _39=/<[a-z][a-z0-9]*[^>]*\s(?:(?:src|href|style)=[^>])+[^>]*>/i;
var _3a=/\s(src|href|style)=(['"]?)([\w()\[\]\/.,\\'"-:;#=&?\s@]+?)\2/i;
var _3b=/^(?:[#]|(?:(?:https?|ftps?|file|javascript|mailto|news):))/;
while(tag=_39.exec(s)){
str+=s.substring(0,tag.index);
s=s.substring((tag.index+tag[0].length),s.length);
tag=tag[0];
_35="";
while(_30=_3a.exec(tag)){
_33="";
_37=_30[3];
switch(_30[1].toLowerCase()){
case "src":
case "href":
if(_3b.exec(_37)){
_33=_37;
}else{
_33=(new dojo.uri.Uri(url,_37).toString());
}
break;
case "style":
_33=dojo.html.fixPathsInCssText(_37,url);
break;
default:
_33=_37;
}
fix=" "+_30[1]+"="+_30[2]+_33+_30[2];
_35+=tag.substring(0,_30.index)+fix;
tag=tag.substring((_30.index+_30[0].length),tag.length);
}
str+=_35+tag;
}
s=str+s;
}
_38=/(?:<(style)[^>]*>([\s\S]*?)<\/style>|<link ([^>]*rel=['"]?stylesheet['"]?[^>]*)>)/i;
while(_2e=_38.exec(s)){
if(_2e[1]&&_2e[1].toLowerCase()=="style"){
_31.push(dojo.html.fixPathsInCssText(_2e[2],url));
}else{
if(_30=_2e[3].match(/href=(['"]?)([^'">]*)\1/i)){
_31.push({path:_30[2]});
}
}
s=s.substring(0,_2e.index)+s.substr(_2e.index+_2e[0].length);
}
var _38=/<script([^>]*)>([\s\S]*?)<\/script>/i;
var _3c=/src=(['"]?)([^"']*)\1/i;
var _3d=/.*(\bdojo\b\.js(?:\.uncompressed\.js)?)$/;
var _3e=/(?:var )?\bdjConfig\b(?:[\s]*=[\s]*\{[^}]+\}|\.[\w]*[\s]*=[\s]*[^;\n]*)?;?|dojo\.hostenv\.writeIncludes\(\s*\);?/g;
var _3f=/dojo\.(?:(?:require(?:After)?(?:If)?)|(?:widget\.(?:manager\.)?registerWidgetPackage)|(?:(?:hostenv\.)?setModulePrefix|registerModulePath)|defineNamespace)\((['"]).*?\1\)\s*;?/;
while(_2e=_38.exec(s)){
if(this.executeScripts&&_2e[1]){
if(_30=_3c.exec(_2e[1])){
if(_3d.exec(_30[2])){
dojo.debug("Security note! inhibit:"+_30[2]+" from  being loaded again.");
}else{
_2c.push({path:_30[2]});
}
}
}
if(_2e[2]){
var sc=_2e[2].replace(_3e,"");
if(!sc){
continue;
}
while(tmp=_3f.exec(sc)){
_2f.push(tmp[0]);
sc=sc.substring(0,tmp.index)+sc.substr(tmp.index+tmp[0].length);
}
if(this.executeScripts){
_2c.push(sc);
}
}
s=s.substr(0,_2e.index)+s.substr(_2e.index+_2e[0].length);
}
if(this.extractContent){
_2e=s.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
if(_2e){
s=_2e[1];
}
}
if(this.executeScripts&&this.scriptSeparation){
var _38=/(<[a-zA-Z][a-zA-Z0-9]*\s[^>]*?\S=)((['"])[^>]*scriptScope[^>]*>)/;
var _41=/([\s'";:\(])scriptScope(.*)/;
str="";
while(tag=_38.exec(s)){
tmp=((tag[3]=="'")?"\"":"'");
fix="";
str+=s.substring(0,tag.index)+tag[1];
while(_30=_41.exec(tag[2])){
tag[2]=tag[2].substring(0,_30.index)+_30[1]+"dojo.widget.byId("+tmp+this.widgetId+tmp+").scriptScope"+_30[2];
}
str+=tag[2];
s=s.substr(tag.index+tag[0].length);
}
s=str+s;
}
}
return {"xml":s,"styles":_31,"titles":_2b,"requires":_2f,"scripts":_2c,"url":url};
},_setContent:function(_42){
this.destroyChildren();
for(var i=0;i<this._styleNodes.length;i++){
if(this._styleNodes[i]&&this._styleNodes[i].parentNode){
this._styleNodes[i].parentNode.removeChild(this._styleNodes[i]);
}
}
this._styleNodes=[];
try{
var _44=this.containerNode||this.domNode;
while(_44.firstChild){
dojo.html.destroyNode(_44.firstChild);
}
if(typeof _42!="string"){
_44.appendChild(_42);
}else{
_44.innerHTML=_42;
}
}
catch(e){
e.text="Couldn't load content:"+e.description;
this._handleDefaults(e,"onContentError");
}
},setContent:function(_45){
this.abort();
if(this._callOnUnload){
this.onUnload();
}
this._callOnUnload=true;
if(!_45||dojo.html.isNode(_45)){
this._setContent(_45);
this.onResized();
this.onLoad();
}else{
if(typeof _45.xml!="string"){
this.href="";
_45=this.splitAndFixPaths(_45);
}
this._setContent(_45.xml);
for(var i=0;i<_45.styles.length;i++){
if(_45.styles[i].path){
this._styleNodes.push(dojo.html.insertCssFile(_45.styles[i].path,dojo.doc(),false,true));
}else{
this._styleNodes.push(dojo.html.insertCssText(_45.styles[i]));
}
}
if(this.parseContent){
for(var i=0;i<_45.requires.length;i++){
try{
eval(_45.requires[i]);
}
catch(e){
e.text="ContentPane: error in package loading calls, "+(e.description||e);
this._handleDefaults(e,"onContentError","debug");
}
}
}
var _47=this;
function asyncParse(){
if(_47.executeScripts){
_47._executeScripts(_45.scripts);
}
if(_47.parseContent){
var _48=_47.containerNode||_47.domNode;
var _49=new dojo.xml.Parse();
var _4a=_49.parseElement(_48,null,true);
dojo.widget.getParser().createSubComponents(_4a,_47);
}
_47.onResized();
_47.onLoad();
}
if(dojo.hostenv.isXDomain&&_45.requires.length){
dojo.addOnLoad(asyncParse);
}else{
asyncParse();
}
}
},setHandler:function(_4b){
var fcn=dojo.lang.isFunction(_4b)?_4b:window[_4b];
if(!dojo.lang.isFunction(fcn)){
this._handleDefaults("Unable to set handler, '"+_4b+"' not a function.","onExecError",true);
return;
}
this.handler=function(){
return fcn.apply(this,arguments);
};
},_runHandler:function(){
var ret=true;
if(dojo.lang.isFunction(this.handler)){
this.handler(this,this.domNode);
ret=false;
}
this.onLoad();
return ret;
},_executeScripts:function(_4e){
var _4f=this;
var tmp="",_51="";
for(var i=0;i<_4e.length;i++){
if(_4e[i].path){
dojo.io.bind(this._cacheSetting({"url":_4e[i].path,"load":function(_53,_54){
dojo.lang.hitch(_4f,tmp=";"+_54);
},"error":function(_55,_56){
_56.text=_55+" downloading remote script";
_4f._handleDefaults.call(_4f,_56,"onExecError","debug");
},"mimetype":"text/plain","sync":true},this.cacheContent));
_51+=tmp;
}else{
_51+=_4e[i];
}
}
try{
if(this.scriptSeparation){
delete this.scriptScope;
this.scriptScope=new (new Function("_container_",_51+"; return this;"))(_4f);
}else{
var djg=dojo.global();
if(djg.execScript){
djg.execScript(_51);
}else{
var djd=dojo.doc();
var sc=djd.createElement("script");
sc.appendChild(djd.createTextNode(_51));
(this.containerNode||this.domNode).appendChild(sc);
}
}
}
catch(e){
e.text="Error running scripts from content:\n"+e.description;
this._handleDefaults(e,"onExecError","debug");
}
}});
dojo.require("dojo.html.common");
dojo.provide("dojo.html.selection");
dojo.require("dojo.dom");
dojo.require("dojo.lang.common");
dojo.html.selectionType={NONE:0,TEXT:1,CONTROL:2};
dojo.html.clearSelection=function(){
var _5a=dojo.global();
var _5b=dojo.doc();
try{
if(_5a["getSelection"]){
if(dojo.render.html.safari){
_5a.getSelection().collapse();
}else{
_5a.getSelection().removeAllRanges();
}
}else{
if(_5b.selection){
if(_5b.selection.empty){
_5b.selection.empty();
}else{
if(_5b.selection.clear){
_5b.selection.clear();
}
}
}
}
return true;
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.html.disableSelection=function(_5c){
_5c=dojo.byId(_5c)||dojo.body();
var h=dojo.render.html;
if(h.mozilla){
_5c.style.MozUserSelect="none";
}else{
if(h.safari){
_5c.style.KhtmlUserSelect="none";
}else{
if(h.ie){
_5c.unselectable="on";
}else{
return false;
}
}
}
return true;
};
dojo.html.enableSelection=function(_5e){
_5e=dojo.byId(_5e)||dojo.body();
var h=dojo.render.html;
if(h.mozilla){
_5e.style.MozUserSelect="";
}else{
if(h.safari){
_5e.style.KhtmlUserSelect="";
}else{
if(h.ie){
_5e.unselectable="off";
}else{
return false;
}
}
}
return true;
};
dojo.html.selectElement=function(_60){
dojo.deprecated("dojo.html.selectElement","replaced by dojo.html.selection.selectElementChildren",0.5);
};
dojo.html.selectInputText=function(_61){
var _62=dojo.global();
var _63=dojo.doc();
_61=dojo.byId(_61);
if(_63["selection"]&&dojo.body()["createTextRange"]){
var _64=_61.createTextRange();
_64.moveStart("character",0);
_64.moveEnd("character",_61.value.length);
_64.select();
}else{
if(_62["getSelection"]){
var _65=_62.getSelection();
_61.setSelectionRange(0,_61.value.length);
}
}
_61.focus();
};
dojo.html.isSelectionCollapsed=function(){
dojo.deprecated("dojo.html.isSelectionCollapsed","replaced by dojo.html.selection.isCollapsed",0.5);
return dojo.html.selection.isCollapsed();
};
dojo.lang.mixin(dojo.html.selection,{getType:function(){
if(dojo.doc()["selection"]){
return dojo.html.selectionType[dojo.doc().selection.type.toUpperCase()];
}else{
var _66=dojo.html.selectionType.TEXT;
var _67;
try{
_67=dojo.global().getSelection();
}
catch(e){
}
if(_67&&_67.rangeCount==1){
var _68=_67.getRangeAt(0);
if(_68.startContainer==_68.endContainer&&(_68.endOffset-_68.startOffset)==1&&_68.startContainer.nodeType!=dojo.dom.TEXT_NODE){
_66=dojo.html.selectionType.CONTROL;
}
}
return _66;
}
},isCollapsed:function(){
var _69=dojo.global();
var _6a=dojo.doc();
if(_6a["selection"]){
return _6a.selection.createRange().text=="";
}else{
if(_69["getSelection"]){
var _6b=_69.getSelection();
if(dojo.lang.isString(_6b)){
return _6b=="";
}else{
return _6b.isCollapsed||_6b.toString()=="";
}
}
}
},getSelectedElement:function(){
if(dojo.html.selection.getType()==dojo.html.selectionType.CONTROL){
if(dojo.doc()["selection"]){
var _6c=dojo.doc().selection.createRange();
if(_6c&&_6c.item){
return dojo.doc().selection.createRange().item(0);
}
}else{
var _6d=dojo.global().getSelection();
return _6d.anchorNode.childNodes[_6d.anchorOffset];
}
}
},getParentElement:function(){
if(dojo.html.selection.getType()==dojo.html.selectionType.CONTROL){
var p=dojo.html.selection.getSelectedElement();
if(p){
return p.parentNode;
}
}else{
if(dojo.doc()["selection"]){
return dojo.doc().selection.createRange().parentElement();
}else{
var _6f=dojo.global().getSelection();
if(_6f){
var _70=_6f.anchorNode;
while(_70&&_70.nodeType!=dojo.dom.ELEMENT_NODE){
_70=_70.parentNode;
}
return _70;
}
}
}
},getSelectedText:function(){
if(dojo.doc()["selection"]){
if(dojo.html.selection.getType()==dojo.html.selectionType.CONTROL){
return null;
}
return dojo.doc().selection.createRange().text;
}else{
var _71=dojo.global().getSelection();
if(_71){
return _71.toString();
}
}
},getSelectedHtml:function(){
if(dojo.doc()["selection"]){
if(dojo.html.selection.getType()==dojo.html.selectionType.CONTROL){
return null;
}
return dojo.doc().selection.createRange().htmlText;
}else{
var _72=dojo.global().getSelection();
if(_72&&_72.rangeCount){
var _73=_72.getRangeAt(0).cloneContents();
var div=document.createElement("div");
div.appendChild(_73);
return div.innerHTML;
}
return null;
}
},hasAncestorElement:function(_75){
return (dojo.html.selection.getAncestorElement.apply(this,arguments)!=null);
},getAncestorElement:function(_76){
var _77=dojo.html.selection.getSelectedElement()||dojo.html.selection.getParentElement();
while(_77){
if(dojo.html.selection.isTag(_77,arguments).length>0){
return _77;
}
_77=_77.parentNode;
}
return null;
},isTag:function(_78,_79){
if(_78&&_78.tagName){
for(var i=0;i<_79.length;i++){
if(_78.tagName.toLowerCase()==String(_79[i]).toLowerCase()){
return String(_79[i]).toLowerCase();
}
}
}
return "";
},selectElement:function(_7b){
var _7c=dojo.global();
var _7d=dojo.doc();
_7b=dojo.byId(_7b);
if(_7d.selection&&dojo.body().createTextRange){
try{
var _7e=dojo.body().createControlRange();
_7e.addElement(_7b);
_7e.select();
}
catch(e){
dojo.html.selection.selectElementChildren(_7b);
}
}else{
if(_7c["getSelection"]){
var _7f=_7c.getSelection();
if(_7f["removeAllRanges"]){
var _7e=_7d.createRange();
_7e.selectNode(_7b);
_7f.removeAllRanges();
_7f.addRange(_7e);
}
}
}
},selectElementChildren:function(_80){
var _81=dojo.global();
var _82=dojo.doc();
_80=dojo.byId(_80);
if(_82.selection&&dojo.body().createTextRange){
var _83=dojo.body().createTextRange();
_83.moveToElementText(_80);
_83.select();
}else{
if(_81["getSelection"]){
var _84=_81.getSelection();
if(_84["setBaseAndExtent"]){
_84.setBaseAndExtent(_80,0,_80,_80.innerText.length-1);
}else{
if(_84["selectAllChildren"]){
_84.selectAllChildren(_80);
}
}
}
}
},getBookmark:function(){
var _85;
var _86=dojo.doc();
if(_86["selection"]){
var _87=_86.selection.createRange();
_85=_87.getBookmark();
}else{
var _88;
try{
_88=dojo.global().getSelection();
}
catch(e){
}
if(_88){
var _87=_88.getRangeAt(0);
_85=_87.cloneRange();
}else{
dojo.debug("No idea how to store the current selection for this browser!");
}
}
return _85;
},moveToBookmark:function(_89){
var _8a=dojo.doc();
if(_8a["selection"]){
var _8b=_8a.selection.createRange();
_8b.moveToBookmark(_89);
_8b.select();
}else{
var _8c;
try{
_8c=dojo.global().getSelection();
}
catch(e){
}
if(_8c&&_8c["removeAllRanges"]){
_8c.removeAllRanges();
_8c.addRange(_89);
}else{
dojo.debug("No idea how to restore selection for this browser!");
}
}
},collapse:function(_8d){
if(dojo.global()["getSelection"]){
var _8e=dojo.global().getSelection();
if(_8e.removeAllRanges){
if(_8d){
_8e.collapseToStart();
}else{
_8e.collapseToEnd();
}
}else{
dojo.global().getSelection().collapse(_8d);
}
}else{
if(dojo.doc().selection){
var _8f=dojo.doc().selection.createRange();
_8f.collapse(_8d);
_8f.select();
}
}
},remove:function(){
if(dojo.doc().selection){
var _90=dojo.doc().selection;
if(_90.type.toUpperCase()!="NONE"){
_90.clear();
}
return _90;
}else{
var _90=dojo.global().getSelection();
for(var i=0;i<_90.rangeCount;i++){
_90.getRangeAt(i).deleteContents();
}
return _90;
}
}});
dojo.provide("dojo.html.iframe");
dojo.require("dojo.html.util");
dojo.html.iframeContentWindow=function(_92){
var win=dojo.html.getDocumentWindow(dojo.html.iframeContentDocument(_92))||dojo.html.iframeContentDocument(_92).__parent__||(_92.name&&document.frames[_92.name])||null;
return win;
};
dojo.html.iframeContentDocument=function(_94){
var doc=_94.contentDocument||((_94.contentWindow)&&(_94.contentWindow.document))||((_94.name)&&(document.frames[_94.name])&&(document.frames[_94.name].document))||null;
return doc;
};
dojo.html.BackgroundIframe=function(_96){
if(dojo.render.html.ie55||dojo.render.html.ie60){
var _97="<iframe src='javascript:false'"+" style='position: absolute; left: 0px; top: 0px; width: 100%; height: 100%;"+"z-index: -1; filter:Alpha(Opacity=\"0\");' "+">";
this.iframe=dojo.doc().createElement(_97);
this.iframe.tabIndex=-1;
if(_96){
_96.appendChild(this.iframe);
this.domNode=_96;
}else{
dojo.body().appendChild(this.iframe);
this.iframe.style.display="none";
}
}
};
dojo.lang.extend(dojo.html.BackgroundIframe,{iframe:null,onResized:function(){
if(this.iframe&&this.domNode&&this.domNode.parentNode){
var _98=dojo.html.getMarginBox(this.domNode);
if(_98.width==0||_98.height==0){
dojo.lang.setTimeout(this,this.onResized,100);
return;
}
this.iframe.style.width=_98.width+"px";
this.iframe.style.height=_98.height+"px";
}
},size:function(_99){
if(!this.iframe){
return;
}
var _9a=dojo.html.toCoordinateObject(_99,true,dojo.html.boxSizing.BORDER_BOX);
with(this.iframe.style){
width=_9a.width+"px";
height=_9a.height+"px";
left=_9a.left+"px";
top=_9a.top+"px";
}
},setZIndex:function(_9b){
if(!this.iframe){
return;
}
if(dojo.dom.isNode(_9b)){
this.iframe.style.zIndex=dojo.html.getStyle(_9b,"z-index")-1;
}else{
if(!isNaN(_9b)){
this.iframe.style.zIndex=_9b;
}
}
},show:function(){
if(this.iframe){
this.iframe.style.display="block";
}
},hide:function(){
if(this.iframe){
this.iframe.style.display="none";
}
},remove:function(){
if(this.iframe){
dojo.html.removeNode(this.iframe,true);
delete this.iframe;
this.iframe=null;
}
}});
dojo.provide("dojo.widget.PopupContainer");
dojo.require("dojo.html.style");
dojo.require("dojo.html.layout");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.declare("dojo.widget.PopupContainerBase",null,function(){
this.queueOnAnimationFinish=[];
},{isShowingNow:false,currentSubpopup:null,beginZIndex:1000,parentPopup:null,parent:null,popupIndex:0,aroundBox:dojo.html.boxSizing.BORDER_BOX,openedForWindow:null,processKey:function(evt){
return false;
},applyPopupBasicStyle:function(){
with(this.domNode.style){
display="none";
position="absolute";
}
},aboutToShow:function(){
},open:function(x,y,_9f,_a0,_a1,_a2){
if(this.isShowingNow){
return;
}
if(this.animationInProgress){
this.queueOnAnimationFinish.push(this.open,arguments);
return;
}
this.aboutToShow();
var _a3=false,_a4,_a5;
if(typeof x=="object"){
_a4=x;
_a5=_a0;
_a0=_9f;
_9f=y;
_a3=true;
}
this.parent=_9f;
dojo.body().appendChild(this.domNode);
_a0=_a0||_9f["domNode"]||[];
var _a6=null;
this.isTopLevel=true;
while(_9f){
if(_9f!==this&&(_9f.setOpenedSubpopup!=undefined&&_9f.applyPopupBasicStyle!=undefined)){
_a6=_9f;
this.isTopLevel=false;
_a6.setOpenedSubpopup(this);
break;
}
_9f=_9f.parent;
}
this.parentPopup=_a6;
this.popupIndex=_a6?_a6.popupIndex+1:1;
if(this.isTopLevel){
var _a7=dojo.html.isNode(_a0)?_a0:null;
dojo.widget.PopupManager.opened(this,_a7);
}
if(this.isTopLevel&&!dojo.withGlobal(this.openedForWindow||dojo.global(),dojo.html.selection.isCollapsed)){
this._bookmark=dojo.withGlobal(this.openedForWindow||dojo.global(),dojo.html.selection.getBookmark);
}else{
this._bookmark=null;
}
if(_a0 instanceof Array){
_a0={left:_a0[0],top:_a0[1],width:0,height:0};
}
with(this.domNode.style){
display="";
zIndex=this.beginZIndex+this.popupIndex;
}
if(_a3){
this.move(_a4,_a2,_a5);
}else{
this.move(x,y,_a2,_a1);
}
this.domNode.style.display="none";
this.explodeSrc=_a0;
this.show();
this.isShowingNow=true;
},move:function(x,y,_aa,_ab){
var _ac=(typeof x=="object");
if(_ac){
var _ad=_aa;
var _ae=x;
_aa=y;
if(!_ad){
_ad={"BL":"TL","TL":"BL"};
}
dojo.html.placeOnScreenAroundElement(this.domNode,_ae,_aa,this.aroundBox,_ad);
}else{
if(!_ab){
_ab="TL,TR,BL,BR";
}
dojo.html.placeOnScreen(this.domNode,x,y,_aa,true,_ab);
}
},close:function(_af){
if(_af){
this.domNode.style.display="none";
}
if(this.animationInProgress){
this.queueOnAnimationFinish.push(this.close,[]);
return;
}
this.closeSubpopup(_af);
this.hide();
if(this.bgIframe){
this.bgIframe.hide();
this.bgIframe.size({left:0,top:0,width:0,height:0});
}
if(this.isTopLevel){
dojo.widget.PopupManager.closed(this);
}
this.isShowingNow=false;
if(this.parent){
setTimeout(dojo.lang.hitch(this,function(){
try{
if(this.parent["focus"]){
this.parent.focus();
}else{
this.parent.domNode.focus();
}
}
catch(e){
dojo.debug("No idea how to focus to parent",e);
}
}),10);
}
if(this._bookmark&&dojo.withGlobal(this.openedForWindow||dojo.global(),dojo.html.selection.isCollapsed)){
if(this.openedForWindow){
this.openedForWindow.focus();
}
try{
dojo.withGlobal(this.openedForWindow||dojo.global(),"moveToBookmark",dojo.html.selection,[this._bookmark]);
}
catch(e){
}
}
this._bookmark=null;
},closeAll:function(_b0){
if(this.parentPopup){
this.parentPopup.closeAll(_b0);
}else{
this.close(_b0);
}
},setOpenedSubpopup:function(_b1){
this.currentSubpopup=_b1;
},closeSubpopup:function(_b2){
if(this.currentSubpopup==null){
return;
}
this.currentSubpopup.close(_b2);
this.currentSubpopup=null;
},onShow:function(){
dojo.widget.PopupContainer.superclass.onShow.apply(this,arguments);
this.openedSize={w:this.domNode.style.width,h:this.domNode.style.height};
if(dojo.render.html.ie){
if(!this.bgIframe){
this.bgIframe=new dojo.html.BackgroundIframe();
this.bgIframe.setZIndex(this.domNode);
}
this.bgIframe.size(this.domNode);
this.bgIframe.show();
}
this.processQueue();
},processQueue:function(){
if(!this.queueOnAnimationFinish.length){
return;
}
var _b3=this.queueOnAnimationFinish.shift();
var _b4=this.queueOnAnimationFinish.shift();
_b3.apply(this,_b4);
},onHide:function(){
dojo.widget.HtmlWidget.prototype.onHide.call(this);
if(this.openedSize){
with(this.domNode.style){
width=this.openedSize.w;
height=this.openedSize.h;
}
}
this.processQueue();
}});
dojo.widget.defineWidget("dojo.widget.PopupContainer",[dojo.widget.HtmlWidget,dojo.widget.PopupContainerBase],{isContainer:true,fillInTemplate:function(){
this.applyPopupBasicStyle();
dojo.widget.PopupContainer.superclass.fillInTemplate.apply(this,arguments);
}});
dojo.widget.PopupManager=new function(){
this.currentMenu=null;
this.currentButton=null;
this.currentFocusMenu=null;
this.focusNode=null;
this.registeredWindows=[];
this.registerWin=function(win){
if(!win.__PopupManagerRegistered){
dojo.event.connect(win.document,"onmousedown",this,"onClick");
dojo.event.connect(win,"onscroll",this,"onClick");
dojo.event.connect(win.document,"onkey",this,"onKey");
win.__PopupManagerRegistered=true;
this.registeredWindows.push(win);
}
};
this.registerAllWindows=function(_b6){
if(!_b6){
_b6=dojo.html.getDocumentWindow(window.top&&window.top.document||window.document);
}
this.registerWin(_b6);
for(var i=0;i<_b6.frames.length;i++){
try{
var win=dojo.html.getDocumentWindow(_b6.frames[i].document);
if(win){
this.registerAllWindows(win);
}
}
catch(e){
}
}
};
this.unRegisterWin=function(win){
if(win.__PopupManagerRegistered){
dojo.event.disconnect(win.document,"onmousedown",this,"onClick");
dojo.event.disconnect(win,"onscroll",this,"onClick");
dojo.event.disconnect(win.document,"onkey",this,"onKey");
win.__PopupManagerRegistered=false;
}
};
this.unRegisterAllWindows=function(){
for(var i=0;i<this.registeredWindows.length;++i){
this.unRegisterWin(this.registeredWindows[i]);
}
this.registeredWindows=[];
};
dojo.addOnLoad(this,"registerAllWindows");
dojo.addOnUnload(this,"unRegisterAllWindows");
this.closed=function(_bb){
if(this.currentMenu==_bb){
this.currentMenu=null;
this.currentButton=null;
this.currentFocusMenu=null;
}
};
this.opened=function(_bc,_bd){
if(_bc==this.currentMenu){
return;
}
if(this.currentMenu){
this.currentMenu.close();
}
this.currentMenu=_bc;
this.currentFocusMenu=_bc;
this.currentButton=_bd;
};
this.setFocusedMenu=function(_be){
this.currentFocusMenu=_be;
};
this.onKey=function(e){
if(!e.key){
return;
}
if(!this.currentMenu||!this.currentMenu.isShowingNow){
return;
}
var m=this.currentFocusMenu;
while(m){
if(m.processKey(e)){
e.preventDefault();
e.stopPropagation();
break;
}
m=m.parentPopup||m.parentMenu;
}
},this.onClick=function(e){
if(!this.currentMenu){
return;
}
var _c2=dojo.html.getScroll().offset;
var m=this.currentMenu;
while(m){
if(dojo.html.overElement(m.domNode,e)||dojo.html.isDescendantOf(e.target,m.domNode)){
return;
}
m=m.currentSubpopup;
}
if(this.currentButton&&dojo.html.overElement(this.currentButton,e)){
return;
}
this.currentMenu.closeAll(true);
};
};
dojo.provide("dojo.widget.Tooltip");
dojo.require("dojo.uri.Uri");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.html.style");
dojo.require("dojo.html.util");
dojo.widget.defineWidget("dojo.widget.Tooltip",[dojo.widget.ContentPane,dojo.widget.PopupContainerBase],{caption:"",showDelay:500,hideDelay:100,connectId:"",templateCssString:".dojoTooltip {\n\tborder: solid black 1px;\n\tbackground: beige;\n\tcolor: black;\n\tposition: absolute;\n\tfont-size: small;\n\tpadding: 2px 2px 2px 2px;\n\tz-index: 10;\n\tdisplay: block;\n}\n",templateCssPath:dojo.uri.moduleUri("dojo.widget","templates/TooltipTemplate.css"),fillInTemplate:function(_c4,_c5){
if(this.caption!=""){
this.domNode.appendChild(document.createTextNode(this.caption));
}
this._connectNode=dojo.byId(this.connectId);
dojo.widget.Tooltip.superclass.fillInTemplate.call(this,_c4,_c5);
this.addOnLoad(this,"_loadedContent");
dojo.html.addClass(this.domNode,"dojoTooltip");
var _c6=this.getFragNodeRef(_c5);
dojo.html.copyStyle(this.domNode,_c6);
this.applyPopupBasicStyle();
},postCreate:function(_c7,_c8){
dojo.event.connect(this._connectNode,"onmouseover",this,"_onMouseOver");
dojo.widget.Tooltip.superclass.postCreate.call(this,_c7,_c8);
},_onMouseOver:function(e){
this._mouse={x:e.pageX,y:e.pageY};
if(!this._tracking){
dojo.event.connect(document.documentElement,"onmousemove",this,"_onMouseMove");
this._tracking=true;
}
this._onHover(e);
},_onMouseMove:function(e){
this._mouse={x:e.pageX,y:e.pageY};
if(dojo.html.overElement(this._connectNode,e)||dojo.html.overElement(this.domNode,e)){
this._onHover(e);
}else{
this._onUnHover(e);
}
},_onHover:function(e){
if(this._hover){
return;
}
this._hover=true;
if(this._hideTimer){
clearTimeout(this._hideTimer);
delete this._hideTimer;
}
if(!this.isShowingNow&&!this._showTimer){
this._showTimer=setTimeout(dojo.lang.hitch(this,"open"),this.showDelay);
}
},_onUnHover:function(e){
if(!this._hover){
return;
}
this._hover=false;
if(this._showTimer){
clearTimeout(this._showTimer);
delete this._showTimer;
}
if(this.isShowingNow&&!this._hideTimer){
this._hideTimer=setTimeout(dojo.lang.hitch(this,"close"),this.hideDelay);
}
if(!this.isShowingNow){
dojo.event.disconnect(document.documentElement,"onmousemove",this,"_onMouseMove");
this._tracking=false;
}
},open:function(){
if(this.isShowingNow){
return;
}
dojo.widget.PopupContainerBase.prototype.open.call(this,this._mouse.x,this._mouse.y,null,[this._mouse.x,this._mouse.y],"TL,TR,BL,BR",[10,15]);
},close:function(){
if(this.isShowingNow){
if(this._showTimer){
clearTimeout(this._showTimer);
delete this._showTimer;
}
if(this._hideTimer){
clearTimeout(this._hideTimer);
delete this._hideTimer;
}
dojo.event.disconnect(document.documentElement,"onmousemove",this,"_onMouseMove");
this._tracking=false;
dojo.widget.PopupContainerBase.prototype.close.call(this);
}
},_position:function(){
this.move(this._mouse.x,this._mouse.y,[10,15],"TL,TR,BL,BR");
},_loadedContent:function(){
if(this.isShowingNow){
this._position();
}
},checkSize:function(){
},uninitialize:function(){
this.close();
dojo.event.disconnect(this._connectNode,"onmouseover",this,"_onMouseOver");
}});
dojo.kwCompoundRequire({common:["dojo.html.common","dojo.html.style"]});
dojo.provide("dojo.html.*");
dojo.provide("dojo.widget.html.stabile");
dojo.widget.html.stabile={_sqQuotables:new RegExp("([\\\\'])","g"),_depth:0,_recur:false,depthLimit:2};
dojo.widget.html.stabile.getState=function(id){
dojo.widget.html.stabile.setup();
return dojo.widget.html.stabile.widgetState[id];
};
dojo.widget.html.stabile.setState=function(id,_cf,_d0){
dojo.widget.html.stabile.setup();
dojo.widget.html.stabile.widgetState[id]=_cf;
if(_d0){
dojo.widget.html.stabile.commit(dojo.widget.html.stabile.widgetState);
}
};
dojo.widget.html.stabile.setup=function(){
if(!dojo.widget.html.stabile.widgetState){
var _d1=dojo.widget.html.stabile._getStorage().value;
dojo.widget.html.stabile.widgetState=_d1?dj_eval("("+_d1+")"):{};
}
};
dojo.widget.html.stabile.commit=function(_d2){
dojo.widget.html.stabile._getStorage().value=dojo.widget.html.stabile.description(_d2);
};
dojo.widget.html.stabile.description=function(v,_d4){
var _d5=dojo.widget.html.stabile._depth;
var _d6=function(){
return this.description(this,true);
};
try{
if(v===void (0)){
return "undefined";
}
if(v===null){
return "null";
}
if(typeof (v)=="boolean"||typeof (v)=="number"||v instanceof Boolean||v instanceof Number){
return v.toString();
}
if(typeof (v)=="string"||v instanceof String){
var v1=v.replace(dojo.widget.html.stabile._sqQuotables,"\\$1");
v1=v1.replace(/\n/g,"\\n");
v1=v1.replace(/\r/g,"\\r");
return "'"+v1+"'";
}
if(v instanceof Date){
return "new Date("+d.getFullYear+","+d.getMonth()+","+d.getDate()+")";
}
var d;
if(v instanceof Array||v.push){
if(_d5>=dojo.widget.html.stabile.depthLimit){
return "[ ... ]";
}
d="[";
var _d9=true;
dojo.widget.html.stabile._depth++;
for(var i=0;i<v.length;i++){
if(_d9){
_d9=false;
}else{
d+=",";
}
d+=arguments.callee(v[i],_d4);
}
return d+"]";
}
if(v.constructor==Object||v.toString==_d6){
if(_d5>=dojo.widget.html.stabile.depthLimit){
return "{ ... }";
}
if(typeof (v.hasOwnProperty)!="function"&&v.prototype){
throw new Error("description: "+v+" not supported by script engine");
}
var _d9=true;
d="{";
dojo.widget.html.stabile._depth++;
for(var key in v){
if(v[key]==void (0)||typeof (v[key])=="function"){
continue;
}
if(_d9){
_d9=false;
}else{
d+=", ";
}
var kd=key;
if(!kd.match(/^[a-zA-Z_][a-zA-Z0-9_]*$/)){
kd=arguments.callee(key,_d4);
}
d+=kd+": "+arguments.callee(v[key],_d4);
}
return d+"}";
}
if(_d4){
if(dojo.widget.html.stabile._recur){
var _dd=Object.prototype.toString;
return _dd.apply(v,[]);
}else{
dojo.widget.html.stabile._recur=true;
return v.toString();
}
}else{
throw new Error("Unknown type: "+v);
return "'unknown'";
}
}
finally{
dojo.widget.html.stabile._depth=_d5;
}
};
dojo.widget.html.stabile._getStorage=function(){
if(dojo.widget.html.stabile.dataField){
return dojo.widget.html.stabile.dataField;
}
var _de=document.forms._dojo_form;
return dojo.widget.html.stabile.dataField=_de?_de.stabile:{value:""};
};
dojo.provide("dojo.widget.ComboBox");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.io.*");
dojo.require("dojo.string");
dojo.declare("dojo.widget.incrementalComboBoxDataProvider",null,function(_df){
this.searchUrl=_df.dataUrl;
this._cache={};
this._inFlight=false;
this._lastRequest=null;
this.allowCache=false;
},{_addToCache:function(_e0,_e1){
if(this.allowCache){
this._cache[_e0]=_e1;
}
},startSearch:function(_e2,_e3){
if(this._inFlight){
}
var tss=encodeURIComponent(_e2);
var _e5=dojo.string.substituteParams(this.searchUrl,{"searchString":tss});
var _e6=this;
var _e7=this._lastRequest=dojo.io.bind({url:_e5,method:"get",mimetype:"text/json",load:function(_e8,_e9,evt){
_e6._inFlight=false;
if(!dojo.lang.isArray(_e9)){
var _eb=[];
for(var key in _e9){
_eb.push([_e9[key],key]);
}
_e9=_eb;
}
_e6._addToCache(_e2,_e9);
if(_e7==_e6._lastRequest){
_e3(_e9);
}
}});
this._inFlight=true;
}});
dojo.declare("dojo.widget.basicComboBoxDataProvider",null,function(_ed,_ee){
this._data=[];
this.searchLimit=30;
this.searchType="STARTSTRING";
this.caseSensitive=false;
if(!dj_undef("dataUrl",_ed)&&!dojo.string.isBlank(_ed.dataUrl)){
this._getData(_ed.dataUrl);
}else{
if((_ee)&&(_ee.nodeName.toLowerCase()=="select")){
var _ef=_ee.getElementsByTagName("option");
var ol=_ef.length;
var _f1=[];
for(var x=0;x<ol;x++){
var _f3=_ef[x].textContent||_ef[x].innerText||_ef[x].innerHTML;
var _f4=[String(_f3),String(_ef[x].value)];
_f1.push(_f4);
if(_ef[x].selected){
_ed.setAllValues(_f4[0],_f4[1]);
}
}
this.setData(_f1);
}
}
},{_getData:function(url){
dojo.io.bind({url:url,load:dojo.lang.hitch(this,function(_f6,_f7,evt){
if(!dojo.lang.isArray(_f7)){
var _f9=[];
for(var key in _f7){
_f9.push([_f7[key],key]);
}
_f7=_f9;
}
this.setData(_f7);
}),mimetype:"text/json"});
},startSearch:function(_fb,_fc){
this._performSearch(_fb,_fc);
},_performSearch:function(_fd,_fe){
var st=this.searchType;
var ret=[];
if(!this.caseSensitive){
_fd=_fd.toLowerCase();
}
for(var x=0;x<this._data.length;x++){
if((this.searchLimit>0)&&(ret.length>=this.searchLimit)){
break;
}
var _102=new String((!this.caseSensitive)?this._data[x][0].toLowerCase():this._data[x][0]);
if(_102.length<_fd.length){
continue;
}
if(st=="STARTSTRING"){
if(_fd==_102.substr(0,_fd.length)){
ret.push(this._data[x]);
}
}else{
if(st=="SUBSTRING"){
if(_102.indexOf(_fd)>=0){
ret.push(this._data[x]);
}
}else{
if(st=="STARTWORD"){
var idx=_102.indexOf(_fd);
if(idx==0){
ret.push(this._data[x]);
}
if(idx<=0){
continue;
}
var _104=false;
while(idx!=-1){
if(" ,/(".indexOf(_102.charAt(idx-1))!=-1){
_104=true;
break;
}
idx=_102.indexOf(_fd,idx+1);
}
if(!_104){
continue;
}else{
ret.push(this._data[x]);
}
}
}
}
}
_fe(ret);
},setData:function(_105){
this._data=_105;
}});
dojo.widget.defineWidget("dojo.widget.ComboBox",dojo.widget.HtmlWidget,{forceValidOption:false,searchType:"stringstart",dataProvider:null,autoComplete:true,searchDelay:100,dataUrl:"",fadeTime:200,maxListLength:8,mode:"local",selectedResult:null,dataProviderClass:"",buttonSrc:dojo.uri.moduleUri("dojo.widget","templates/images/combo_box_arrow.png"),dropdownToggle:"fade",templateString:"<span _=\"whitespace and CR's between tags adds &nbsp; in FF\"\n\tclass=\"dojoComboBoxOuter\"\n\t><input style=\"display:none\"  tabindex=\"-1\" name=\"\" value=\"\" \n\t\tdojoAttachPoint=\"comboBoxValue\"\n\t><input style=\"display:none\"  tabindex=\"-1\" name=\"\" value=\"\" \n\t\tdojoAttachPoint=\"comboBoxSelectionValue\"\n\t><input type=\"text\" autocomplete=\"off\" class=\"dojoComboBox\"\n\t\tdojoAttachEvent=\"key:_handleKeyEvents; keyUp: onKeyUp; compositionEnd; onResize;\"\n\t\tdojoAttachPoint=\"textInputNode\"\n\t><img hspace=\"0\"\n\t\tvspace=\"0\"\n\t\tclass=\"dojoComboBox\"\n\t\tdojoAttachPoint=\"downArrowNode\"\n\t\tdojoAttachEvent=\"onMouseUp: handleArrowClick; onResize;\"\n\t\tsrc=\"${this.buttonSrc}\"\n></span>\n",templateCssString:".dojoComboBoxOuter {\n\tborder: 0px !important;\n\tmargin: 0px !important;\n\tpadding: 0px !important;\n\tbackground: transparent !important;\n\twhite-space: nowrap !important;\n}\n\n.dojoComboBox {\n\tborder: 1px inset #afafaf;\n\tmargin: 0px;\n\tpadding: 0px;\n\tvertical-align: middle !important;\n\tfloat: none !important;\n\tposition: static !important;\n\tdisplay: inline !important;\n}\n\n/* the input box */\ninput.dojoComboBox {\n\tborder-right-width: 0px !important; \n\tmargin-right: 0px !important;\n\tpadding-right: 0px !important;\n}\n\n/* the down arrow */\nimg.dojoComboBox {\n\tborder-left-width: 0px !important;\n\tpadding-left: 0px !important;\n\tmargin-left: 0px !important;\n}\n\n/* IE vertical-alignment calculations can be off by +-1 but these margins are collapsed away */\n.dj_ie img.dojoComboBox {\n\tmargin-top: 1px; \n\tmargin-bottom: 1px; \n}\n\n/* the drop down */\n.dojoComboBoxOptions {\n\tfont-family: Verdana, Helvetica, Garamond, sans-serif;\n\t/* font-size: 0.7em; */\n\tbackground-color: white;\n\tborder: 1px solid #afafaf;\n\tposition: absolute;\n\tz-index: 1000; \n\toverflow: auto;\n\tcursor: default;\n}\n\n.dojoComboBoxItem {\n\tpadding-left: 2px;\n\tpadding-top: 2px;\n\tmargin: 0px;\n}\n\n.dojoComboBoxItemEven {\n\tbackground-color: #f4f4f4;\n}\n\n.dojoComboBoxItemOdd {\n\tbackground-color: white;\n}\n\n.dojoComboBoxItemHighlight {\n\tbackground-color: #63709A;\n\tcolor: white;\n}\n",templateCssPath:dojo.uri.moduleUri("dojo.widget","templates/ComboBox.css"),setValue:function(_106){
this.comboBoxValue.value=_106;
if(this.textInputNode.value!=_106){
this.textInputNode.value=_106;
dojo.widget.html.stabile.setState(this.widgetId,this.getState(),true);
this.onValueChanged(_106);
}
},onValueChanged:function(_107){
},getValue:function(){
return this.comboBoxValue.value;
},getState:function(){
return {value:this.getValue()};
},setState:function(_108){
this.setValue(_108.value);
},enable:function(){
this.disabled=false;
this.textInputNode.removeAttribute("disabled");
},disable:function(){
this.disabled=true;
this.textInputNode.setAttribute("disabled",true);
},_getCaretPos:function(_109){
if(dojo.lang.isNumber(_109.selectionStart)){
return _109.selectionStart;
}else{
if(dojo.render.html.ie){
var tr=document.selection.createRange().duplicate();
var ntr=_109.createTextRange();
tr.move("character",0);
ntr.move("character",0);
try{
ntr.setEndPoint("EndToEnd",tr);
return String(ntr.text).replace(/\r/g,"").length;
}
catch(e){
return 0;
}
}
}
},_setCaretPos:function(_10c,_10d){
_10d=parseInt(_10d);
this._setSelectedRange(_10c,_10d,_10d);
},_setSelectedRange:function(_10e,_10f,end){
if(!end){
end=_10e.value.length;
}
if(_10e.setSelectionRange){
_10e.focus();
_10e.setSelectionRange(_10f,end);
}else{
if(_10e.createTextRange){
var _111=_10e.createTextRange();
with(_111){
collapse(true);
moveEnd("character",end);
moveStart("character",_10f);
select();
}
}else{
_10e.value=_10e.value;
_10e.blur();
_10e.focus();
var dist=parseInt(_10e.value.length)-end;
var _113=String.fromCharCode(37);
var tcc=_113.charCodeAt(0);
for(var x=0;x<dist;x++){
var te=document.createEvent("KeyEvents");
te.initKeyEvent("keypress",true,true,null,false,false,false,false,tcc,tcc);
_10e.dispatchEvent(te);
}
}
}
},_handleKeyEvents:function(evt){
if(evt.ctrlKey||evt.altKey||!evt.key){
return;
}
this._prev_key_backspace=false;
this._prev_key_esc=false;
var k=dojo.event.browser.keys;
var _119=true;
switch(evt.key){
case k.KEY_DOWN_ARROW:
if(!this.popupWidget.isShowingNow){
this._startSearchFromInput();
}
this._highlightNextOption();
dojo.event.browser.stopEvent(evt);
return;
case k.KEY_UP_ARROW:
this._highlightPrevOption();
dojo.event.browser.stopEvent(evt);
return;
case k.KEY_TAB:
if(!this.autoComplete&&this.popupWidget.isShowingNow&&this._highlighted_option){
dojo.event.browser.stopEvent(evt);
this._selectOption({"target":this._highlighted_option,"noHide":false});
this._setSelectedRange(this.textInputNode,this.textInputNode.value.length,null);
}else{
this._selectOption();
return;
}
break;
case k.KEY_ENTER:
if(this.popupWidget.isShowingNow){
dojo.event.browser.stopEvent(evt);
}
if(this.autoComplete){
this._selectOption();
return;
}
case " ":
if(this.popupWidget.isShowingNow&&this._highlighted_option){
dojo.event.browser.stopEvent(evt);
this._selectOption();
this._hideResultList();
return;
}
break;
case k.KEY_ESCAPE:
this._hideResultList();
this._prev_key_esc=true;
return;
case k.KEY_BACKSPACE:
this._prev_key_backspace=true;
if(!this.textInputNode.value.length){
this.setAllValues("","");
this._hideResultList();
_119=false;
}
break;
case k.KEY_RIGHT_ARROW:
case k.KEY_LEFT_ARROW:
_119=false;
break;
default:
if(evt.charCode==0){
_119=false;
}
}
if(this.searchTimer){
clearTimeout(this.searchTimer);
}
if(_119){
this._blurOptionNode();
this.searchTimer=setTimeout(dojo.lang.hitch(this,this._startSearchFromInput),this.searchDelay);
}
},compositionEnd:function(evt){
evt.key=evt.keyCode;
this._handleKeyEvents(evt);
},onKeyUp:function(evt){
this.setValue(this.textInputNode.value);
},setSelectedValue:function(_11c){
this.comboBoxSelectionValue.value=_11c;
},setAllValues:function(_11d,_11e){
this.setSelectedValue(_11e);
this.setValue(_11d);
},_focusOptionNode:function(node){
if(this._highlighted_option!=node){
this._blurOptionNode();
this._highlighted_option=node;
dojo.html.addClass(this._highlighted_option,"dojoComboBoxItemHighlight");
}
},_blurOptionNode:function(){
if(this._highlighted_option){
dojo.html.removeClass(this._highlighted_option,"dojoComboBoxItemHighlight");
this._highlighted_option=null;
}
},_highlightNextOption:function(){
if((!this._highlighted_option)||!this._highlighted_option.parentNode){
this._focusOptionNode(this.optionsListNode.firstChild);
}else{
if(this._highlighted_option.nextSibling){
this._focusOptionNode(this._highlighted_option.nextSibling);
}
}
dojo.html.scrollIntoView(this._highlighted_option);
},_highlightPrevOption:function(){
if(this._highlighted_option&&this._highlighted_option.previousSibling){
this._focusOptionNode(this._highlighted_option.previousSibling);
}else{
this._highlighted_option=null;
this._hideResultList();
return;
}
dojo.html.scrollIntoView(this._highlighted_option);
},_itemMouseOver:function(evt){
if(evt.target===this.optionsListNode){
return;
}
this._focusOptionNode(evt.target);
dojo.html.addClass(this._highlighted_option,"dojoComboBoxItemHighlight");
},_itemMouseOut:function(evt){
if(evt.target===this.optionsListNode){
return;
}
this._blurOptionNode();
},onResize:function(){
var _122=dojo.html.getContentBox(this.textInputNode);
if(_122.height<=0){
dojo.lang.setTimeout(this,"onResize",100);
return;
}
var _123={width:_122.height,height:_122.height};
dojo.html.setContentBox(this.downArrowNode,_123);
},fillInTemplate:function(args,frag){
dojo.html.applyBrowserClass(this.domNode);
var _126=this.getFragNodeRef(frag);
if(!this.name&&_126.name){
this.name=_126.name;
}
this.comboBoxValue.name=this.name;
this.comboBoxSelectionValue.name=this.name+"_selected";
dojo.html.copyStyle(this.domNode,_126);
dojo.html.copyStyle(this.textInputNode,_126);
dojo.html.copyStyle(this.downArrowNode,_126);
with(this.downArrowNode.style){
width="0px";
height="0px";
}
var _127;
if(this.dataProviderClass){
if(typeof this.dataProviderClass=="string"){
_127=dojo.evalObjPath(this.dataProviderClass);
}else{
_127=this.dataProviderClass;
}
}else{
if(this.mode=="remote"){
_127=dojo.widget.incrementalComboBoxDataProvider;
}else{
_127=dojo.widget.basicComboBoxDataProvider;
}
}
this.dataProvider=new _127(this,this.getFragNodeRef(frag));
this.popupWidget=new dojo.widget.createWidget("PopupContainer",{toggle:this.dropdownToggle,toggleDuration:this.toggleDuration});
dojo.event.connect(this,"destroy",this.popupWidget,"destroy");
this.optionsListNode=this.popupWidget.domNode;
this.domNode.appendChild(this.optionsListNode);
dojo.html.addClass(this.optionsListNode,"dojoComboBoxOptions");
dojo.event.connect(this.optionsListNode,"onclick",this,"_selectOption");
dojo.event.connect(this.optionsListNode,"onmouseover",this,"_onMouseOver");
dojo.event.connect(this.optionsListNode,"onmouseout",this,"_onMouseOut");
dojo.event.connect(this.optionsListNode,"onmouseover",this,"_itemMouseOver");
dojo.event.connect(this.optionsListNode,"onmouseout",this,"_itemMouseOut");
},_openResultList:function(_128){
if(this.disabled){
return;
}
this._clearResultList();
if(!_128.length){
this._hideResultList();
}
if((this.autoComplete)&&(_128.length)&&(!this._prev_key_backspace)&&(this.textInputNode.value.length>0)){
var cpos=this._getCaretPos(this.textInputNode);
if((cpos+1)>this.textInputNode.value.length){
this.textInputNode.value+=_128[0][0].substr(cpos);
this._setSelectedRange(this.textInputNode,cpos,this.textInputNode.value.length);
}
}
var even=true;
while(_128.length){
var tr=_128.shift();
if(tr){
var td=document.createElement("div");
td.appendChild(document.createTextNode(tr[0]));
td.setAttribute("resultName",tr[0]);
td.setAttribute("resultValue",tr[1]);
td.className="dojoComboBoxItem "+((even)?"dojoComboBoxItemEven":"dojoComboBoxItemOdd");
even=(!even);
this.optionsListNode.appendChild(td);
}
}
this._showResultList();
},_onFocusInput:function(){
this._hasFocus=true;
},_onBlurInput:function(){
this._hasFocus=false;
this._handleBlurTimer(true,500);
},_handleBlurTimer:function(_12d,_12e){
if(this.blurTimer&&(_12d||_12e)){
clearTimeout(this.blurTimer);
}
if(_12e){
this.blurTimer=dojo.lang.setTimeout(this,"_checkBlurred",_12e);
}
},_onMouseOver:function(evt){
if(!this._mouseover_list){
this._handleBlurTimer(true,0);
this._mouseover_list=true;
}
},_onMouseOut:function(evt){
var _131=evt.relatedTarget;
try{
if(!_131||_131.parentNode!=this.optionsListNode){
this._mouseover_list=false;
this._handleBlurTimer(true,100);
this._tryFocus();
}
}
catch(e){
}
},_isInputEqualToResult:function(_132){
var _133=this.textInputNode.value;
if(!this.dataProvider.caseSensitive){
_133=_133.toLowerCase();
_132=_132.toLowerCase();
}
return (_133==_132);
},_isValidOption:function(){
var tgt=dojo.html.firstElement(this.optionsListNode);
var _135=false;
while(!_135&&tgt){
if(this._isInputEqualToResult(tgt.getAttribute("resultName"))){
_135=true;
}else{
tgt=dojo.html.nextElement(tgt);
}
}
return _135;
},_checkBlurred:function(){
if(!this._hasFocus&&!this._mouseover_list){
this._hideResultList();
if(!this.textInputNode.value.length){
this.setAllValues("","");
return;
}
var _136=this._isValidOption();
if(this.forceValidOption&&!_136){
this.setAllValues("","");
return;
}
if(!_136){
this.setSelectedValue("");
}
}
},_selectOption:function(evt){
var tgt=null;
if(!evt){
evt={target:this._highlighted_option};
}
if(!dojo.html.isDescendantOf(evt.target,this.optionsListNode)){
if(!this.textInputNode.value.length){
return;
}
tgt=dojo.html.firstElement(this.optionsListNode);
if(!tgt||!this._isInputEqualToResult(tgt.getAttribute("resultName"))){
return;
}
}else{
tgt=evt.target;
}
while((tgt.nodeType!=1)||(!tgt.getAttribute("resultName"))){
tgt=tgt.parentNode;
if(tgt===dojo.body()){
return false;
}
}
this.selectedResult=[tgt.getAttribute("resultName"),tgt.getAttribute("resultValue")];
this.setAllValues(tgt.getAttribute("resultName"),tgt.getAttribute("resultValue"));
if(!evt.noHide){
this._hideResultList();
this._setSelectedRange(this.textInputNode,0,null);
}
this._tryFocus();
},_clearResultList:function(){
if(this.optionsListNode.innerHTML){
this.optionsListNode.innerHTML="";
}
},_hideResultList:function(){
this.popupWidget.close();
},_showResultList:function(){
var _139=this.optionsListNode.childNodes;
if(_139.length){
var _13a=Math.min(_139.length,this.maxListLength);
with(this.optionsListNode.style){
display="";
if(_13a==_139.length){
height="";
}else{
height=_13a*dojo.html.getMarginBox(_139[0]).height+"px";
}
width=(dojo.html.getMarginBox(this.domNode).width-2)+"px";
}
this.popupWidget.open(this.domNode,this,this.downArrowNode);
}else{
this._hideResultList();
}
},handleArrowClick:function(){
this._handleBlurTimer(true,0);
this._tryFocus();
if(this.popupWidget.isShowingNow){
this._hideResultList();
}else{
this._startSearch("");
}
},_tryFocus:function(){
try{
this.textInputNode.focus();
}
catch(e){
}
},_startSearchFromInput:function(){
this._startSearch(this.textInputNode.value);
},_startSearch:function(key){
this.dataProvider.startSearch(key,dojo.lang.hitch(this,"_openResultList"));
},postCreate:function(){
this.onResize();
dojo.event.connect(this.textInputNode,"onblur",this,"_onBlurInput");
dojo.event.connect(this.textInputNode,"onfocus",this,"_onFocusInput");
if(this.disabled){
this.disable();
}
var s=dojo.widget.html.stabile.getState(this.widgetId);
if(s){
this.setState(s);
}
}});
